# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Params-Util
Version:	1.102
Release:	11.%{__distinit}%{__distvers}
Summary:	Simple standalone param-checking functions
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Params-Util
Source0:	https://cpan.metacpan.org/modules/by-module/Params/Params-Util-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::CBuilder) >= 0.27
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
# Dependencies of bundled inc::latest, Capture::Tiny and Config::AutoConf
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(PerlIO)
BuildRequires:	perl(Text::ParseWords)
# Module Runtime
BuildRequires:	perl(Exporter)
BuildRequires:	perl(overload)
BuildRequires:	perl(parent)
BuildRequires:	perl(Scalar::Util) >= 1.18
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(vars)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Scalar::Util) >= 1.18

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
Params::Util provides a basic set of importable functions that
makes checking parameters a hell of a lot easier.

%prep
%setup -q -n Params-Util-%{version}

# Fix bogus exec permission
chmod -c -x Changes

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test AUTOMATED_TESTING=1

%files
%license ARTISTIC-1.0 GPL-1 LICENSE
%doc Changes README.md
%{perl_vendorarch}/Params/
%{perl_vendorarch}/auto/Params/
%{_mandir}/man3/Params::Util.3*
%{_mandir}/man3/Params::Util::PP.3*

%changelog
* Tue Jul 11 2023 Paul Howarth <paul@city-fan.org> - 1.102-11
- Use SPDX-format license tag

* Tue May 31 2022 Paul Howarth <paul@city-fan.org> - 1.102-7
- Perl 5.36 rebuild

* Fri May 21 2021 Paul Howarth <paul@city-fan.org> - 1.102-3
- Perl 5.34 rebuild

* Mon Nov  2 2020 Paul Howarth <paul@city-fan.org> - 1.102-1
- Update to 1.102
  - Fix installation in pureperl mode (CPAN RT#133623)
  - Update ppport.h using Devel::PPPort 3.62

* Thu Oct 22 2020 Paul Howarth <paul@city-fan.org> - 1.101-1
- Update to 1.101
  - Fix inconsistent license conditions in metadata and documentation and add
    appropriate LICENSE files (CPAN RT#133586)

* Wed Oct 21 2020 Paul Howarth <paul@city-fan.org> - 1.100-1
- Update to 1.100
  - Refactor tooling to get reasonable author tests and code/distribution
    quality checks (CPAN RT#81924, CPAN RT#109106)
  - Separate PP code into dedicated module
  - Fix spelling errors (CPAN RT#86356, CPAN RT#115910)
  - Fix CPAN RT#87649 (_CLASS) and CPAN RT#81276 (_POSINT) plus similar fixes
    for _STRING, _IDENTIFIER, _NUMBER and _NONNEGINT
  - Mention _INSTANCEDOES and _CLASSDOES in Changes (CPAN RT#79995)
  - Fix build breakage in 1.07 (CPAN RT#79856)

* Wed Jun 24 2020 Paul Howarth <paul@city-fan.org> - 1.07-30
- Perl 5.32 rebuild

* Thu May 30 2019 Paul Howarth <paul@city-fan.org> - 1.07-27
- Perl 5.30 rebuild

* Sat Jul 21 2018 Paul Howarth <paul@city-fan.org> - 1.07-25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 1.07-23
- Perl 5.28 rebuild

* Fri Mar 23 2018 Paul Howarth <paul@city-fan.org> - 1.07-22
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop workaround for supporting builds with ExtUtils::MakeMaker < 6.52 and
  Scalar::Util < 1.18

* Sun Jun  4 2017 Paul Howarth <paul@city-fan.org> - 1.07-18
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally

* Thu Sep 15 2016 Paul Howarth <paul@city-fan.org> - 1.07-16
- Classify buildreqs by usage
- Simplify find commands using -empty and -delete

* Mon Sep  1 2014 Paul Howarth <paul@city-fan.org> - 1.07-10
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Thu Jul 18 2013 Paul Howarth <paul@city-fan.org> - 1.07-6
- Perl 5.18 rebuild

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 1.07-3
- Perl 5.16 post-bootstrap rebuild

* Sun Jul  1 2012 Paul Howarth <paul@city-fan.org> - 1.07-2
- Drop buildreqs for Perl core modules that aren't actually dual-lived
- BR: perl(File::Spec::Functions)

* Sun Mar 11 2012 Paul Howarth <paul@city-fan.org> - 1.07-1
- Update to 1.07
  - Disable XS version on cygwin as it shows bizarre behaviour that breaks
    form when using Params::Util XS version
- Drop support for distributions older than FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation
- Update patch for old ExtUtils::MakeMaker and Scalar::Util versions

* Thu Mar  1 2012 Paul Howarth <paul@city-fan.org> - 1.06-1
- Update to 1.06
  - Remove the need for the sanexs.c file by generating into a temporary file
    instead
- Update patch for old ExtUtils::MakeMaker and Scalar::Util versions

* Thu Mar  1 2012 Paul Howarth <paul@city-fan.org> - 1.05-1
- Update to 1.05
  - Restore compatibility with pre-5.8.8 Perls without a working compiler
    available at install time (CPAN RT#74912)
  - Added _CLASSDOES and _INSTANCEDOES
- Drop Scalar::Util version requirement to 1.09
- Patch out overspecified version requirements for ExtUtils::MakeMaker ≥ 6.52
  and Scalar::Util ≥ 1.10/1.18
- Don't need to remove empty directories from the buildroot
- Add buildreqs for Perl core modules that might be dual-lived
- Package README
- Use PERL_INSTALL_ROOT rather than DESTDIR now that we have compatibility
  with RHL-9 again
- Don't use %%{_fixperms} macro now that we have compatibility with RHL-9 again

* Mon Feb  6 2012 Paul Howarth <paul@city-fan.org> - 1.04-3
- Don't BR: perl(Test::MinimumVersion) when bootstrapping
- Use DESTDIR rather than PERL_INSTALL_ROOT
- Explicitly run the release tests, separately from the main test suite

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 1.04-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Apr 20 2011 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
  - Fix have_compiler returns false, can_xs returns true (CPAN RT#67522)
- Use %%{_fixperms} macro rather than our own chmod incantation
- Nobody else likes macros for commands

* Mon Nov 22 2010 Paul Howarth <paul@city-fan.org> - 1.03-1
- Update to 1.03
  - Add a much more advanced can_xs() alternative to can_cc() to deal with
    the situation where a host has a superficially working compiler, but
    completely screwed up headers
  - Add some fallback strategies to deal with cases where these same machines
    don't support configure_requires
  - Adopt Chorny's eumm-upgrade style for the Makefile.PL
  - Allow the Makefile.PL to build its own META.yml now

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 1.01-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed Jun  2 2010 Paul Howarth <paul@city-fan.org> - 1.01-2
- Fix dist tag for RHEL-6 Beta

* Thu Mar 18 2010 Paul Howarth <paul@city-fan.org> - 1.01-1
- Update to 1.01 (fixed can_cc() bug in Makefile.PL - CPAN RT#55668)
- Don't run tests in verbose mode

* Sun Feb 28 2010 Paul Howarth <paul@city-fan.org> - 1.00-3
- Dist tag for Rawhide no longer needs special-casing

* Tue Sep 22 2009 Paul Howarth <paul@city-fan.org> - 1.00-2
- Use %%{?perl_default_filter} for provides filter

* Mon Jun  1 2009 Paul Howarth <paul@city-fan.org> - 1.00-1
- Update to 1.00
- * remove experimental flags
- * fix XS implementation of _*LIKE and _INSTANCE
- * add test for a negative custom isa returning ('')
- * improved the 'clean' file list in a Makefile.PL
- Drop Scalar::Util requirement back down from 1.18 to 1.14 for FC3 compat

* Mon Mar  2 2009 Paul Howarth <paul@city-fan.org> - 0.38-2
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Tue Feb 17 2009 Paul Howarth <paul@city-fan.org> - 0.38-1
- Update to 0.38 (fix _IDENTIFIER and _CLASS to return false for "foo\n")

* Thu Feb  5 2009 Paul Howarth <paul@city-fan.org> - 0.37-1
- Update to 0.37 (bleadperl fixes)

* Mon Feb  2 2009 Paul Howarth <paul@city-fan.org> - 0.36-1
- Update to 0.36

* Tue Nov 11 2008 Paul Howarth <paul@city-fan.org> - 0.35-1
- Update to 0.35
- Package is now arch-specific
- AUTOMATED_TESTING re-enabled
- Permissions OK in tarball now
- Bump version requirement of Test::CPAN::Meta to 0.12

* Mon Sep  1 2008 Paul Howarth <paul@city-fan.org> - 0.33-3
- Import from Fedora
- Drop perl(Test::CPAN::Meta) and perl(Test::MinimumVersion) buildreqs for now
- Disable AUTOMATED_TESTING for now (t/99_pmv.t test failing)

* Tue Jul 08 2008 Ralf Corsépius <rc040203@freenet.de> - 0.33-2
- Unconditionally BR: perl(Test::CPAN::Meta).

* Mon Jun 02 2008 Ralf Corsépius <rc040203@freenet.de> - 0.33-1
- Upstream update.
- Conditionally BR: perl(Test::CPAN::Meta).
- Hack testsuite to accept Test::CPAN::Meta != 0.07.

* Thu Feb 28 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.31-6
- Rebuild normally, second pass

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.31-5
- Rebuild for perl 5.10 (again), first pass

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.31-4
- rebuild normally, second pass

* Sat Jan 12 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.31-3.1
- disable Test::MinimumVersion, tests for first pass

* Fri Jan 11 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.31-3
- rebuild for new perl

* Sun Nov 25 2007 Ralf Corsépius <rc040203@freenet.de> - 0.31-2
- Add BR: perl(Test::MinimumVersion).

* Mon Nov 19 2007 Ralf Corsépius <rc040203@freenet.de> - 0.31-1
- Upstream update.

* Tue Oct 30 2007 Ralf Corsépius <rc040203@freenet.de> - 0.30-1
- Upstream update.

* Thu Sep 06 2007 Ralf Corsépius <rc040203@freenet.de> - 0.29-1
- Upstream update.
- Update licence tag.
- Conditionally disable AUTOMATED_TESTING.

* Sat Jul 28 2007 Ralf Corsépius <rc040203@freenet.de> - 0.26-1
- Upstream update.

* Wed May 30 2007 Ralf Corsépius <rc040203@freenet.de> - 0.25-1
- Upstream update.

* Mon May 14 2007 Ralf Corsépius <rc040203@freenet.de> - 0.24-1
- Upstream update.

* Mon Mar 12 2007 Ralf Corsépius <rc040203@freenet.de> - 0.23-2
- BR: perl(ExtUtils::MakeMaker).

* Fri Mar 02 2007 Ralf Corsépius <rc040203@freenet.de> - 0.23-1
- Upstream update.

* Fri Nov 03 2006 Ralf Corsépius <rc040203@freenet.de> - 0.22-1
- Upstream update.

* Thu Oct 19 2006 Ralf Corsépius <rc040203@freenet.de> - 0.21-1
- Upstream update.

* Wed Oct 04 2006 Ralf Corsépius <rc040203@freenet.de> - 0.20-1
- Upstream update.

* Mon Sep 18 2006 Ralf Corsépius <rc040203@freenet.de> - 0.19-1
- Upstream update.
- Activate AUTOMATED_TESTING (t/99_author.t).

* Tue Sep 05 2006 Ralf Corsépius <rc040203@freenet.de> - 0.17-2
- Mass rebuild.

* Sun Aug 13 2006 Ralf Corsépius <rc040203@freenet.de> - 0.17-1
- Upstream update.

* Wed Jul 05 2006 Ralf Corsépius <rc040203@freenet.de> - 0.15-1
- Upstream update.

* Sun May 21 2006 Ralf Corsépius <rc040203@freenet.de> - 0.14-1
- Upstream update.

* Mon May 08 2006 Ralf Corsépius <rc040203@freenet.de> - 0.13-1
- Upstream update.

* Thu Apr 20 2006 Ralf Corsépius <rc040203@freenet.de> - 0.11-1
- Upstream update.

* Wed Mar 01 2006 Ralf Corsépius <rc040203@freenet.de> - 0.10-2
- Rebuild for perl-5.8.8.

* Wed Jan 18 2006 Ralf Corsépius <rc040203@freenet.de> - 0.10-1
- Upstream update.

* Wed Jan 11 2006 Ralf Corsépius <rc040203@freenet.de> - 0.09-1
- Upstream update.

* Wed Dec 21 2005 Ralf Corsépius <rc040203@freenet.de> - 0.08-1
- Upstream update.

* Wed Oct 12 2005 Ralf Corsepius <rc040203@freenet.de> - 0.07-1
- Upstream update.
